/*

	initalisation de la ds

*/
#include <nds.h>
#include <fat.h>
#include <stdio.h>
#include <malloc.h>
	#include "protos.h"
	#include "weapon.h"


void Vbl_func()
{
	if( Vbl_compteur == 60)
	{
		FPS = compteur;
		Vbl_compteur = 0;
		compteur = 0;
	}
	
	Vbl_compteur++;
}


void init(void)
{
	compteur = 0; Vbl_compteur = 0; FPS = 0;
	joueur.posX = 0; joueur.posY = 0; joueur.angle = 90, joueur.view = 0;
	emit = 0;
	
	// Turn on everything
	powerON(POWER_ALL);

	// Setup the Main screen for 3D 
	videoSetMode(MODE_5_3D | DISPLAY_BG2_ACTIVE | DISPLAY_BG3_ACTIVE);
	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE);
	vramSetMainBanks(VRAM_A_MAIN_BG, VRAM_B_TEXTURE, VRAM_C_SUB_BG, VRAM_D_LCD);
	
	// IRQ basic setup
	irqInit();
		irqSet(IRQ_VBLANK, Vbl_func);
		irqEnable(IRQ_VBLANK);
	
	BG2_CR = BG_BMP16_256x256 | BG_BMP_BASE(0);
	BG0_CR = BG_PRIORITY(3);
	SUB_BG0_CR = BG_MAP_BASE(31);
	BG_PALETTE_SUB[255] = RGB15(31,31,31);
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);
	drawBitmap((u16*)weaponBitmap, 0, 0, 256, 192, 0, 0x7C1F);
	
	BG2_XDX = 1 << 8;
    BG2_XDY = 0;
    BG2_YDX = 0;
    BG2_YDY = 1 << 8;
	//scroll
    BG2_CX = 0;
    BG2_CY = 0;
	

	// initialize the geometry engine
	glInit();
	
	glEnable(GL_TEXTURE_2D);
	glEnable(GL_ANTIALIAS);
	
	// setup the rear plane
	glClearColor(16,16,31,31); // BG must be opaque for AA to work
	glClearPolyID(63); // BG must have a unique polygon ID for AA to work
	glClearDepth(0x7FFF);

	// Set our viewport to be the same size as the screen
	glViewport(0,0,255,191);
	
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspectivef32((70 * LUT_SIZE / 360), (256 / 192)<<12, 10, (2<<12));
	
	// Set the current matrix to be the model matrix
	glMatrixMode(GL_MODELVIEW);
	
	//ds specific, several attributes can be set here	
	glPolyFmt(POLY_ALPHA(31) | POLY_CULL_BACK);
	
	fatInitDefault();
	
	setGenericSound(11025, 127, 64, 1);
}


void LoadWorld()
{
	FILE* fichier = fopen("map.txt", "r");
	
		fread(&carte.sX, 1, 1, fichier);
		fread(&carte.sY, 1, 1, fichier);
		
		if(carte.sX > carte.sY)
			carte.cubeSize = inttov16(1) / carte.sX;
		else
			carte.cubeSize = inttov16(1) / carte.sY;
		
		joueur.posX = carte.cubeSize * (carte.sX / 2);
		joueur.posY = carte.cubeSize * (carte.sY / 2);
		
			carte.map = (u8*)malloc(carte.sX * carte.sY);
		
		fread(carte.map, 1, carte.sX * carte.sY, fichier);
	
	fclose(fichier);
}

